/* WRAPPER */
.ts-wrapper {
    display: block;
    width: 100%;
    min-height: 36px;
    position: relative;

    &.has-items {
        .items-placeholder {
            display: none !important;
        }
    }

    &:not(.has-items) {
        .ts-control {
            padding-inline-start: .75rem !important;
        }
    }

    &.single {
        &.dropdown-active {
            .ts-control {
                &:after {
                    transform: rotate(180deg);
                }
            }
        }

        .ts-control {
            input {
                width: 100%;
                outline: none;
            }
        }
    }
}


.ts-wrapper.single .ts-control .clear-button,
.ts-wrapper.single.has-items .ts-control input {
    display: none;
}

/* CONTROL */
.ts-control {
    display: flex;
    align-items: center;
    flex-wrap: wrap;
    width: 100%;
    min-height: 48px;
    position: relative;
    z-index: 1;
    overflow: hidden;
    outline: none;
    padding-inline: .75rem;

    &:after {
        content: " ";
        display: block;
        width: 1.25rem;
        height: 1.25rem;
        position: absolute;
        right: .75rem;
        bottom: calc((46px / 2) - (1.25rem / 2));
        /* chevron */
        background-color: var(--color-foreground-bright);
        mask-image: url("data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHdpZHRoPSIyNCIgaGVpZ2h0PSIyNCIgdmlld0JveD0iMCAwIDI0IDI0IiBmaWxsPSJub25lIiBzdHJva2U9ImN1cnJlbnRDb2xvciIgc3Ryb2tlLXdpZHRoPSIyIiBzdHJva2UtbGluZWNhcD0icm91bmQiIHN0cm9rZS1saW5lam9pbj0icm91bmQiIGNsYXNzPSJsdWNpZGUgbHVjaWRlLWNoZXZyb24tZG93biI+PHBhdGggZD0ibTYgOSA2IDYgNi02Ii8+PC9zdmc+");
        mask-repeat: no-repeat;
        mask-position: center;
        mask-size: 100%;
    }

    > .item {
        display: block;
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
    }

    > .item[data-value=""] {
        color: var(--color-placeholder);
    }
}

/* DROPDOWN */
.ts-dropdown {
    width: 100%;
    position: absolute;
    z-index: 1001;
    top: calc(100% + .375rem);
    left: 0;
    box-sizing: border-box;
    padding: calc(var(--spacing) * 2);
    color: var(--color-foreground);
    border-width: 1px;
    border-color: var(--color-border);
    border-radius: var(--radius-exp);
    background-color: var(--color-surface-alt);
    padding-block-end: 0;
}

.ts-dropdown-content {
    display: flex;
    flex-direction: column;
    max-height: 200px;
    position: relative;
    overflow: hidden auto;
    border-top-left-radius: var(--radius-sm);
    border-top-right-radius: var(--radius-sm);
    scroll-behavior: smooth;
    row-gap: .25rem;

    .spinner {
        display: none;
    }

    [data-selectable] {
        .highlight {
            font-weight: 600;
        }
    }

    .no-results {
        padding: 1rem;
        font-weight: 500;
        text-align: center;
    }
}

/* OPTIONS */
.ts-dropdown .option {
    flex-shrink: 0;
    border-radius: var(--radius-md);
    padding-block: calc(var(--spacing) * 1.5);
    padding-inline: calc(var(--spacing) * 2);

    &:last-child {
        margin-block-end: .25rem;
    }

    &.selected {
        font-weight: 600;
        color: var(--color-foreground);
        background-color: var(--color-surface-bright);
    }

    &:not(.selected) {
        &.active {
            color: var(--color-background);
            background-color: var(--color-neutral-300);
        }
    }
}

.ts-dropdown-content {
    .optgroup {
        display: flex;
        flex-direction: column;
        row-gap: .25rem;

        .optgroup-header {
            position: sticky;
            top: 0;
            font-weight: 500;
            font-size: 1rem;
            color: var(--color-muted-foreground);
            background-color: var(--color-background);
            padding-block: .375rem;
            padding-inline: .75rem;
        }

        .option {

        }
    }
}

/* PLUGINS */
.plugin-dropdown_input.ts-wrapper.single .ts-control > .item {
    display: flex;
    align-items: center;
}

.plugin-dropdown_input.ts-wrapper:not(.multi) .ts-control > .item {
    width: calc(100% - 1.625rem);
}

.ts-wrapper.multi .ts-control {
    gap: .25rem;
}

.plugin-dropdown_input.ts-wrapper.multi .ts-control {
    padding-block: .25rem;
    padding-inline-start: .25rem;
    padding-inline-end: 2.725rem;
}

.plugin-dropdown_input.ts-wrapper.multi .ts-control > .item {
    display: inline-flex;
    align-items: center;
    height: 1.75rem;
    font-weight: 500;
    font-size: .875rem;
    line-height: 1rem;
    color: var(--color-secondary-foreground);
    border: 1px solid var(--color-border);
    border-radius: var(--radius-sm);
    background-color: var(--color-background);
    padding-block: .375rem;
    padding-inline: .5rem;
}

.plugin-dropdown_input.ts-wrapper.multi .ts-control > .item:has(.remove) {
    padding-inline-end: .25rem;
}

.plugin-dropdown_input.ts-wrapper .ts-control > .item .remove {
    display: flex;
    align-items: center;
    flex-shrink: 0;
    justify-content: center;
    width: 1em;
    height: 1em;
    border-radius: var(--radius-sm);
}

.plugin-dropdown_input.ts-wrapper.multi .ts-control > .item .remove {
    font-size: 1rem;
    color: var(--color-destructive-foreground);
    background-color: var(--color-destructive);
    margin-inline-start: .25rem;
}

.plugin-dropdown_input.ts-wrapper.single .ts-control > .item .remove {
    font-size: 1.25rem;
    color: var(--color-destructive-foreground);
    background-color: var(--color-destructive);
    margin-inline-start: auto;
}

.plugin-dropdown_input.ts-wrapper .ts-control > .item .remove:hover {
    color: var(--color-reverse-foreground);
    background-color: var(--color-destructive-foreground);
}

.plugin-dropdown_input.ts-wrapper.multi .ts-control .items-placeholder {
    flex-grow: 1;
}

.plugin-dropdown_input.ts-wrapper .ts-control,
.plugin-dropdown_input.ts-wrapper .items-placeholder {
    cursor: pointer;
}

.plugin-dropdown_input.ts-wrapper:not(.multi) .items-placeholder {
    width: 100%;
}

.plugin-dropdown_input .dropdown-input-wrap {
    display: flex;
    align-items: center;
    margin-bottom: .25rem;
    border-width: 1px;
    border-color: var(--color-border);
    border-radius: var(--radius-md);
    column-gap: .75rem;
    padding-block: .375rem;
    padding-inline: .75rem;
}

.plugin-dropdown_input .dropdown-input-wrap:before {
    content: " ";
    display: block;
    flex-shrink: 0;
    width: 1rem;
    height: 1rem;
    /* search */
    background-color: var(--color-muted-foreground);
    mask-image: url("data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHdpZHRoPSIxZW0iIGhlaWdodD0iMWVtIiB2aWV3Qm94PSIwIDAgMjQgMjQiPjxnIGZpbGw9Im5vbmUiIHN0cm9rZT0iY3VycmVudENvbG9yIiBzdHJva2UtbGluZWNhcD0icm91bmQiIHN0cm9rZS1saW5lam9pbj0icm91bmQiIHN0cm9rZS13aWR0aD0iMiI+PGNpcmNsZSBjeD0iMTEiIGN5PSIxMSIgcj0iOCIvPjxwYXRoIGQ9Im0yMSAyMWwtNC4zLTQuMyIvPjwvZz48L3N2Zz4=");
    mask-repeat: no-repeat;
    mask-position: center;
    mask-size: 100%;
}

.plugin-dropdown_input.loading .dropdown-input-wrap:before {
    animation: spin 1s linear infinite;
    /* loader */
    background-color: var(--color-foreground);
    mask-image: url("data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHdpZHRoPSIyNCIgaGVpZ2h0PSIyNCIgdmlld0JveD0iMCAwIDI0IDI0IiBmaWxsPSJub25lIiBzdHJva2U9ImN1cnJlbnRDb2xvciIgc3Ryb2tlLXdpZHRoPSIyIiBzdHJva2UtbGluZWNhcD0icm91bmQiIHN0cm9rZS1saW5lam9pbj0icm91bmQiIGNsYXNzPSJsdWNpZGUgbHVjaWRlLWxvYWRlci1jaXJjbGUiPjxwYXRoIGQ9Ik0yMSAxMmE5IDkgMCAxIDEtNi4yMTktOC41NiIvPjwvc3ZnPg==");
}

.plugin-dropdown_input .option.loading-more-results {
    color: var(--color-muted-foreground);
}

.plugin-dropdown_input .option.no-more-results {
    padding: 1rem;
    font-weight: 500;
    text-align: center;
}

.plugin-dropdown_input .dropdown-input {
    display: block;
    width: 100%;
    outline: none;
    background: transparent;
}

.group select.ts-hidden-accessible {
    width: 1px !important;
    height: 1px !important;
    position: absolute !important;
    overflow: hidden !important;
    clip: rect(0 0 0 0) !important;
    padding: 0 !important;
    white-space: nowrap !important;
    border: 0 !important;
    clip-path: inset(50%) !important;
}
